import threading

#input_variables = get_property_names(inputVariables)
#    for name in input_variables:
def helper_get_property_names(cls):
    return list(cls.__annotations__.keys())


#properties = helper_get_property_names_and_values(MyClass)
#for name, value in properties.items():
    #print(f"{name}: {value}")
def helper_get_property_names_and_values(cls):
    properties = {}
    for attr in cls.__annotations__:
        # Der Wert wird aus dem Klassenattribut direkt geholt, vorausgesetzt, es ist initialisiert.
        value = getattr(cls, attr, None)
        properties[attr] = value
    return properties

PickPosition = tuple[float, float, float]
PlacePosition = tuple[float, float, float]

class AxisHelper:
    def __init__(self, inputVariables, outputVariables, startOutputPropertyName, targetPositionOutputPropertyName, doneOutputPropertyName):
        self.InstanceInputVariables = inputVariables
        self.InstanceOutputVariables = outputVariables
        self.StartOutputPropertyName = startOutputPropertyName
        self.TargetPositionOutputPropertyName = targetPositionOutputPropertyName
        self.DoneOutputPropertyName = doneOutputPropertyName

    # Setzt das Ziel der Bewegung
    def SetTarget(self, value):
        setattr(self.InstanceOutputVariables, self.TargetPositionOutputPropertyName, value)

    # Startet die Bewegung
    def SetValueStart(self, value):
        setattr(self.InstanceOutputVariables, self.StartOutputPropertyName, value)

    # Startet die Bewegung zur Zielposition
    def MoveTo(self, targetPosition):    
        self.SetTarget(targetPosition)
        self.SetValueStart(True)
        # Verzögerung, um die Bewegung zu simulieren
        threading.Timer(0.5, self.SetValueStart, [False]).start()        

    # Prüft, ob die Bewegung abgeschlossen ist
    def IsReady(self):
        ready=getattr(self.InstanceInputVariables, self.DoneOutputPropertyName)
        return ready
